home *** CD-ROM | disk | FTP | other *** search
/ PC World Komputer 2010 April / PCWorld0410.iso / hity wydania / Ubuntu 9.10 PL / karmelkowy-koliberek-desktop-9.10-i386-PL.iso / casper / filesystem.squashfs / var / lib / dpkg / info / x11-common.preinst < prev    next >
Text File  |  2009-10-19  |  30KB  |  910 lines

  1. #!/bin/sh
  2. # Debian x11-common package pre-installation script
  3. # Copyright 1998--2001, 2003 Branden Robinson.
  4. # Licensed under the GNU General Public License, version 2.  See the file
  5. # /usr/share/common-licenses/GPL or <http://www.gnu.org/copyleft/gpl.txt>.
  6. # Acknowlegements to Stephen Early, Mark Eichin, and Manoj Srivastava.
  7.  
  8. set -e
  9.  
  10. . /usr/share/debconf/confmodule
  11.  
  12. THIS_PACKAGE=x11-common
  13. THIS_SCRIPT=preinst
  14. CONFIG_DIR=/etc/X11
  15. XWRAPPER_CONFIG="$CONFIG_DIR/Xwrapper.config"
  16. CONFIG_AUX_DIR=/var/lib/x11
  17. XWRAPPER_CONFIG_ROSTER_BASE="${XWRAPPER_CONFIG##*/}.roster"
  18. XWRAPPER_CONFIG_ROSTER="$CONFIG_AUX_DIR/$XWRAPPER_CONFIG_ROSTER_BASE"
  19. XWRAPPER_CONFIG_CHECKSUM_BASE="${XWRAPPER_CONFIG##*/}.md5sum"
  20. XWRAPPER_CONFIG_CHECKSUM="$CONFIG_AUX_DIR/$XWRAPPER_CONFIG_CHECKSUM_BASE"
  21.  
  22. # $Id$
  23.  
  24. # This is the X Strike Force shell library for X Window System package
  25. # maintainer scripts.  It serves to define shell functions commonly used by
  26. # such packages, and performs some error checking necessary for proper operation
  27. # of those functions.  By itself, it does not "do" much; the maintainer scripts
  28. # invoke the functions defined here to accomplish package installation and
  29. # removal tasks.
  30.  
  31. # If you are reading this within a Debian package maintainer script (e.g.,
  32. # /var/lib/dpkg)info/PACKAGE.{config,preinst,postinst,prerm,postrm}), you can
  33. # skip past this library by scanning forward in this file to the string
  34. # "GOBSTOPPER".
  35.  
  36. SOURCE_VERSION=1:7.4+3ubuntu7
  37. OFFICIAL_BUILD=
  38.  
  39. # Use special abnormal exit codes so that problems with this library are more
  40. # easily tracked down.
  41. SHELL_LIB_INTERNAL_ERROR=86
  42. SHELL_LIB_THROWN_ERROR=74
  43. SHELL_LIB_USAGE_ERROR=99
  44.  
  45. # old -> new variable names
  46. if [ -z "$DEBUG_XORG_PACKAGE" ] && [ -n "$DEBUG_XFREE86_PACKAGE" ]; then
  47.   DEBUG_XORG_PACKAGE="$DEBUG_XFREE86_PACKAGE"
  48. fi
  49. if [ -z "$DEBUG_XORG_DEBCONF" ] && [ -n "$DEBUG_XFREE86_DEBCONF" ]; then
  50.   DEBUG_XORG_DEBCONF="$DEBUG_XFREE86_DEBCONF"
  51. fi
  52.  
  53. # initial sanity checks
  54. if [ -z "$THIS_PACKAGE" ]; then
  55.   cat >&2 <<EOF
  56. Error: package maintainer script attempted to use shell library without
  57. definining \$THIS_PACKAGE shell variable.  Please report the package name,
  58. version, and the text of this error message to the Debian Bug Tracking System.
  59. Visit <http://www.debian.org/Bugs/Reporting> on the World Wide Web for
  60. instructions, read the file /usr/share/doc/debian/bug-reporting.txt from the
  61. "doc-debian" package, or install the "reportbug" package and use the command of
  62. the same name to file a report against version $SOURCE_VERSION of this package.
  63. EOF
  64.   exit $SHELL_LIB_USAGE_ERROR
  65. fi
  66.  
  67. if [ -z "$THIS_SCRIPT" ]; then
  68.   cat >&2 <<EOF
  69. Error: package maintainer script attempted to use shell library without
  70. definining \$THIS_SCRIPT shell variable.  Please report the package name,
  71. version, and the text of this error message to the Debian Bug Tracking System.
  72. Visit <http://www.debian.org/Bugs/Reporting> on the World Wide Web for
  73. instructions, read the file /usr/share/doc/debian/bug-reporting.txt from the
  74. "doc-debian" package, or install the "reportbug" package and use the command of
  75. the same name to file a report against version $SOURCE_VERSION of the
  76. "$THIS_PACKAGE" package.
  77. EOF
  78.   exit $SHELL_LIB_USAGE_ERROR
  79. fi
  80.  
  81. if [ "$1" = "reconfigure" ] || [ -n "$DEBCONF_RECONFIGURE" ]; then
  82.   RECONFIGURE="true"
  83. else
  84.   RECONFIGURE=
  85. fi
  86.  
  87. if ([ "$1" = "install" ] || [ "$1" = "configure" ]) && [ -z "$2" ]; then
  88.   FIRSTINST="yes"
  89. fi
  90.  
  91. if [ -z "$RECONFIGURE" ] && [ -z "$FIRSTINST" ]; then
  92.   UPGRADE="yes"
  93. fi
  94.  
  95. trap "message;\
  96.       message \"Received signal.  Aborting $THIS_PACKAGE package $THIS_SCRIPT script.\";\
  97.       message;\
  98.       exit 1" HUP INT QUIT TERM
  99.  
  100. reject_nondigits () {
  101.   # syntax: reject_nondigits [ operand ... ]
  102.   #
  103.   # scan operands (typically shell variables whose values cannot be trusted) for
  104.   # characters other than decimal digits and barf if any are found
  105.   while [ -n "$1" ]; do
  106.     # does the operand contain anything but digits?
  107.     if ! expr "$1" : "[[:digit:]]\+$" > /dev/null 2>&1; then
  108.       # can't use die(), because it wraps message() which wraps this function
  109.       echo "$THIS_PACKAGE $THIS_SCRIPT error: reject_nondigits() encountered" \
  110.            "possibly malicious garbage \"$1\"" >&2
  111.       exit $SHELL_LIB_THROWN_ERROR
  112.     fi
  113.     shift
  114.   done
  115. }
  116.  
  117. reject_whitespace () {
  118.   # syntax: reject_whitespace [ operand ]
  119.   #
  120.   # scan operand (typically a shell variable whose value cannot be trusted) for
  121.   # whitespace characters and barf if any are found
  122.   if [ -n "$1" ]; then
  123.     # does the operand contain any whitespace?
  124.     if expr "$1" : "[[:space:]]" > /dev/null 2>&1; then
  125.       # can't use die(), because I want to avoid forward references
  126.       echo "$THIS_PACKAGE $THIS_SCRIPT error: reject_whitespace() encountered" \
  127.            "possibly malicious garbage \"$1\"" >&2
  128.       exit $SHELL_LIB_THROWN_ERROR
  129.     fi
  130.   fi
  131. }
  132.  
  133. reject_unlikely_path_chars () {
  134.   # syntax: reject_unlikely_path_chars [ operand ... ]
  135.   #
  136.   # scan operands (typically shell variables whose values cannot be trusted) for
  137.   # characters unlikely to be seen in a path and which the shell might
  138.   # interpret and barf if any are found
  139.   while [ -n "$1" ]; do
  140.     # does the operand contain any funny characters?
  141.     if expr "$1" : '.*[!$&()*;<>?|].*' > /dev/null 2>&1; then
  142.       # can't use die(), because I want to avoid forward references
  143.       echo "$THIS_PACKAGE $THIS_SCRIPT error: reject_unlikely_path_chars()" \
  144.            "encountered possibly malicious garbage \"$1\"" >&2
  145.       exit $SHELL_LIB_THROWN_ERROR
  146.     fi
  147.     shift
  148.   done
  149. }
  150.  
  151. # Query the terminal to establish a default number of columns to use for
  152. # displaying messages to the user.  This is used only as a fallback in the
  153. # event the COLUMNS variable is not set.  ($COLUMNS can react to SIGWINCH while
  154. # the script is running, and this cannot, only being calculated once.)
  155. DEFCOLUMNS=$(stty size 2> /dev/null | awk '{print $2}') || true
  156. if ! expr "$DEFCOLUMNS" : "[[:digit:]]\+$" > /dev/null 2>&1; then
  157.   DEFCOLUMNS=80
  158. fi
  159.  
  160. message () {
  161.   # pretty-print messages of arbitrary length
  162.   reject_nondigits "$COLUMNS"
  163.   echo "$*" | fmt -t -w ${COLUMNS:-$DEFCOLUMNS} >&2
  164. }
  165.  
  166. observe () {
  167.   # syntax: observe message ...
  168.   #
  169.   # issue observational message suitable for logging someday when support for
  170.   # it exists in dpkg
  171.   if [ -n "$DEBUG_XORG_PACKAGE" ]; then
  172.     message "$THIS_PACKAGE $THIS_SCRIPT note: $*"
  173.   fi
  174. }
  175.  
  176. warn () {
  177.   # syntax: warn message ...
  178.   #
  179.   # issue warning message suitable for logging someday when support for
  180.   # it exists in dpkg; also send to standard error
  181.   message "$THIS_PACKAGE $THIS_SCRIPT warning: $*"
  182. }
  183.  
  184. die () {
  185.   # syntax: die message ...
  186.   #
  187.   # exit script with error message
  188.   message "$THIS_PACKAGE $THIS_SCRIPT error: $*"
  189.   exit $SHELL_LIB_THROWN_ERROR
  190. }
  191.  
  192. internal_error () {
  193.   # exit script with error; essentially a "THIS SHOULD NEVER HAPPEN" message
  194.   message "internal error: $*"
  195.   if [ -n "$OFFICIAL_BUILD" ]; then
  196.     message "Please report a bug in the $THIS_SCRIPT script of the" \
  197.             "$THIS_PACKAGE package, version $SOURCE_VERSION to the Debian Bug" \
  198.             "Tracking System.  Include all messages above that mention the" \
  199.             "$THIS_PACKAGE package.  Visit " \
  200.             "<http://www.debian.org/Bugs/Reporting> on the World Wide Web for" \
  201.             "instructions, read the file" \
  202.             "/usr/share/doc/debian/bug-reporting.txt from the doc-debian" \
  203.             "package, or install the reportbug package and use the command of" \
  204.             "the same name to file a report."
  205.   fi
  206.   exit $SHELL_LIB_INTERNAL_ERROR
  207. }
  208.  
  209. usage_error () {
  210.   message "usage error: $*"
  211.   message "Please report a bug in the $THIS_SCRIPT script of the" \
  212.           "$THIS_PACKAGE package, version $SOURCE_VERSION to the Debian Bug" \
  213.           "Tracking System.  Include all messages above that mention the" \
  214.           "$THIS_PACKAGE package.  Visit " \
  215.           "<http://www.debian.org/Bugs/Reporting> on the World Wide Web for" \
  216.           "instructions, read the file" \
  217.           "/usr/share/doc/debian/bug-reporting.txt from the doc-debian" \
  218.           "package, or install the reportbug package and use the command of" \
  219.           "the same name to file a report."
  220.   exit $SHELL_LIB_USAGE_ERROR
  221. }
  222.  
  223.  
  224. maplink () {
  225.   # returns what symlink should point to; i.e., what the "sane" answer is
  226.   # Keep this in sync with the debian/*.links files.
  227.   # This is only needed for symlinks to directories.
  228.   #
  229.   # XXX: Most of these look wrong in the X11R7 world and need to be fixed.
  230.   # If we've stopped using this function, fixing it might enable us to re-enable
  231.   # it again and catch more errors.
  232.   case "$1" in
  233.     /etc/X11/xkb/compiled) echo /var/lib/xkb ;;
  234.     /etc/X11/xkb/xkbcomp) echo /usr/X11R6/bin/xkbcomp ;;
  235.     /usr/X11R6/lib/X11/app-defaults) echo /etc/X11/app-defaults ;;
  236.     /usr/X11R6/lib/X11/fs) echo /etc/X11/fs ;;
  237.     /usr/X11R6/lib/X11/lbxproxy) echo /etc/X11/lbxproxy ;;
  238.     /usr/X11R6/lib/X11/proxymngr) echo /etc/X11/proxymngr ;;
  239.     /usr/X11R6/lib/X11/rstart) echo /etc/X11/rstart ;;
  240.     /usr/X11R6/lib/X11/twm) echo /etc/X11/twm ;;
  241.     /usr/X11R6/lib/X11/xdm) echo /etc/X11/xdm ;;
  242.     /usr/X11R6/lib/X11/xinit) echo /etc/X11/xinit ;;
  243.     /usr/X11R6/lib/X11/xkb) echo /etc/X11/xkb ;;
  244.     /usr/X11R6/lib/X11/xserver) echo /etc/X11/xserver ;;
  245.     /usr/X11R6/lib/X11/xsm) echo /etc/X11/xsm ;;
  246.     /usr/bin/X11) echo ../X11R6/bin ;;
  247.     /usr/bin/rstartd) echo ../X11R6/bin/rstartd ;;
  248.     /usr/include/X11) echo ../X11R6/include/X11 ;;
  249.     /usr/lib/X11) echo ../X11R6/lib/X11 ;;
  250.     *) internal_error "maplink() called with unknown path \"$1\"" ;;
  251.   esac
  252. }
  253.  
  254. analyze_path () {
  255.   # given a supplied set of pathnames, break each one up by directory and do an
  256.   # ls -dl on each component, cumulatively; i.e.
  257.   # analyze_path /usr/X11R6/bin -> ls -dl /usr /usr/X11R6 /usr/X11R6/bin
  258.   # Thanks to Randolph Chung for this clever hack.
  259.  
  260.   local f g
  261.  
  262.   while [ -n "$1" ]; do
  263.     reject_whitespace "$1"
  264.     g=
  265.     message "Analyzing $1:"
  266.     for f in $(echo "$1" | tr / \  ); do
  267.       if [ -e /$g$f ]; then
  268.         ls -dl /$g$f /$g$f.dpkg-* 2> /dev/null || true
  269.         g=$g$f/
  270.       else
  271.         message "/$g$f: nonexistent; directory contents of /$g:"
  272.         ls -l /$g
  273.         break
  274.       fi
  275.     done
  276.     shift
  277.   done
  278. }
  279.  
  280. find_culprits () {
  281.   local f p dpkg_info_dir possible_culprits smoking_guns bad_packages package \
  282.     msg
  283.  
  284.   reject_whitespace "$1"
  285.   message "Searching for overlapping packages..."
  286.   dpkg_info_dir=/var/lib/dpkg/info
  287.   if [ -d $dpkg_info_dir ]; then
  288.     if [ "$(echo $dpkg_info_dir/*.list)" != "$dpkg_info_dir/*.list" ]; then
  289.       possible_culprits=$(ls -1 $dpkg_info_dir/*.list | egrep -v \
  290.         "(xbase-clients|x11-common|xfs|xlibs)")
  291.       if [ -n "$possible_culprits" ]; then
  292.         smoking_guns=$(grep -l "$1" $possible_culprits || true)
  293.         if [ -n "$smoking_guns" ]; then
  294.           bad_packages=$(printf "\\n")
  295.           for f in $smoking_guns; do
  296.             # too bad you can't nest parameter expansion voodoo
  297.             p=${f%*.list}      # strip off the trailing ".list"
  298.             package=${p##*/}   # strip off the directories
  299.             bad_packages=$(printf "%s\n%s" "$bad_packages" "$package")
  300.           done
  301.           msg=$(cat <<EOF
  302. The following packages appear to have file overlaps with the X.Org packages;
  303. these packages are either very old, or in violation of Debian Policy.  Try
  304. upgrading each of these packages to the latest available version if possible:
  305. for example, with the command "apt-get install".  If no newer version of a
  306. package is available, you will have to remove it; for example, with the command
  307. "apt-get remove".  If even the latest available version of the package has
  308. this file overlap, please file a bug against that package with the Debian Bug
  309. Tracking System.  You may want to refer the package maintainer to section 12.8
  310. of the Debian Policy manual.
  311. EOF
  312. )
  313.           message "$msg"
  314.           message "The overlapping packages are: $bad_packages"
  315.         else
  316.           message "no overlaps found."
  317.         fi
  318.       fi
  319.     else
  320.       message "cannot search; no matches for $dpkg_info_dir/*.list."
  321.     fi
  322.   else
  323.     message "cannot search; $dpkg_info_dir does not exist."
  324.   fi
  325. }
  326.  
  327. check_symlink () {
  328.   # syntax: check_symlink symlink
  329.   #
  330.   # See if specified symlink points where it is supposed to.  Return 0 if it
  331.   # does, and 1 if it does not.
  332.   #
  333.   # Primarily used by check_symlinks_and_warn() and check_symlinks_and_bomb().
  334.  
  335.   local symlink
  336.  
  337.   # validate arguments
  338.   if [ $# -ne 1 ]; then
  339.     usage_error "check_symlink() called with wrong number of arguments;" \
  340.                 "expected 1, got $#"
  341.     exit $SHELL_LIB_USAGE_ERROR
  342.   fi
  343.  
  344.   symlink="$1"
  345.  
  346.   if [ "$(maplink "$symlink")" = "$(readlink "$symlink")" ]; then
  347.     return 0
  348.   else
  349.     return 1
  350.   fi
  351. }
  352.  
  353. check_symlinks_and_warn () {
  354.   # syntax: check_symlinks_and_warn symlink ...
  355.   #
  356.   # For each argument, check for symlink sanity, and warn if it isn't sane.
  357.   #
  358.   # Call this function from a preinst script in the event $1 is "upgrade" or
  359.   # "install".
  360.  
  361.   local errmsg symlink
  362.  
  363.   # validate arguments
  364.   if [ $# -lt 1 ]; then
  365.     usage_error "check_symlinks_and_warn() called with wrong number of" \
  366.                 "arguments; expected at least 1, got $#"
  367.     exit $SHELL_LIB_USAGE_ERROR
  368.   fi
  369.  
  370.   while [ -n "$1" ]; do
  371.     symlink="$1"
  372.     if [ -L "$symlink" ]; then
  373.       if ! check_symlink "$symlink"; then
  374.         observe "$symlink symbolic link points to wrong location" \
  375.                 "$(readlink "$symlink"); removing"
  376.         rm "$symlink"
  377.       fi
  378.     elif [ -e "$symlink" ]; then
  379.       errmsg="$symlink exists and is not a symbolic link; this package cannot"
  380.       errmsg="$errmsg be installed until this"
  381.       if [ -f "$symlink" ]; then
  382.         errmsg="$errmsg file"
  383.       elif [ -d "$symlink" ]; then
  384.         errmsg="$errmsg directory"
  385.       else
  386.         errmsg="$errmsg thing"
  387.       fi
  388.       errmsg="$errmsg is removed"
  389.       die "$errmsg"
  390.     fi
  391.     shift
  392.   done
  393. }
  394.  
  395. check_symlinks_and_bomb () {
  396.   # syntax: check_symlinks_and_bomb symlink ...
  397.   #
  398.   # For each argument, check for symlink sanity, and bomb if it isn't sane.
  399.   #
  400.   # Call this function from a postinst script.
  401.  
  402.   local problem symlink
  403.  
  404.   # validate arguments
  405.   if [ $# -lt 1 ]; then
  406.     usage_error "check_symlinks_and_bomb() called with wrong number of"
  407.                 "arguments; expected at least 1, got $#"
  408.     exit $SHELL_LIB_USAGE_ERROR
  409.   fi
  410.  
  411.   while [ -n "$1" ]; do
  412.     problem=
  413.     symlink="$1"
  414.     if [ -L "$symlink" ]; then
  415.       if ! check_symlink "$symlink"; then
  416.         problem=yes
  417.         warn "$symlink symbolic link points to wrong location" \
  418.              "$(readlink "$symlink")"
  419.       fi
  420.     elif [ -e "$symlink" ]; then
  421.       problem=yes
  422.       warn "$symlink is not a symbolic link"
  423.     else
  424.       problem=yes
  425.       warn "$symlink symbolic link does not exist"
  426.     fi
  427.     if [ -n "$problem" ]; then
  428.       analyze_path "$symlink" "$(readlink "$symlink")"
  429.       find_culprits "$symlink"
  430.       die "bad symbolic links on system"
  431.     fi
  432.     shift
  433.   done
  434. }
  435.  
  436. font_update () {
  437.   # run $UPDATECMDS in $FONTDIRS
  438.  
  439.   local dir cmd shortcmd x_font_dir_prefix
  440.  
  441.   x_font_dir_prefix="/usr/share/fonts/X11"
  442.  
  443.   if [ -z "$UPDATECMDS" ]; then
  444.     usage_error "font_update() called but \$UPDATECMDS not set"
  445.   fi
  446.   if [ -z "$FONTDIRS" ]; then
  447.     usage_error "font_update() called but \$FONTDIRS not set"
  448.   fi
  449.  
  450.   reject_unlikely_path_chars "$UPDATECMDS"
  451.   reject_unlikely_path_chars "$FONTDIRS"
  452.  
  453.   for dir in $FONTDIRS; do
  454.     if [ -d "$x_font_dir_prefix/$dir" ]; then
  455.       for cmd in $UPDATECMDS; do
  456.         if which "$cmd" > /dev/null 2>&1; then
  457.           shortcmd=${cmd##*/}
  458.           observe "running $shortcmd in $dir font directory"
  459.       cmd_opts=
  460.           if [ "$shortcmd" = "update-fonts-alias" ]; then
  461.             cmd_opts=--x11r7-layout
  462.           fi
  463.           if [ "$shortcmd" = "update-fonts-dir" ]; then
  464.             cmd_opts=--x11r7-layout
  465.           fi
  466.           if [ "$shortcmd" = "update-fonts-scale" ]; then
  467.             cmd_opts=--x11r7-layout
  468.           fi
  469.           $cmd $cmd_opts $dir || warn "$cmd $cmd_opts $dir" \
  470.                               "failed; font directory data may not" \
  471.                               "be up to date"
  472.         else
  473.           warn "$cmd not found; not updating corresponding $dir font" \
  474.                "directory data"
  475.         fi
  476.       done
  477.     else
  478.       warn "$dir is not a directory; not updating font directory data"
  479.     fi
  480.   done
  481. }
  482.  
  483. remove_conffile_prepare () {
  484.   # syntax: remove_conffile_prepare filename official_md5sum ...
  485.   #
  486.   # Check a conffile "filename" against a list of canonical MD5 checksums.
  487.   # If the file's current MD5 checksum matches one of the "official_md5sum"
  488.   # operands provided, then prepare the conffile for removal from the system.
  489.   # We defer actual deletion until the package is configured so that we can
  490.   # roll this operation back if package installation fails.
  491.   #
  492.   # Call this function from a preinst script in the event $1 is "upgrade" or
  493.   # "install" and verify $2 to ensure the package is being upgraded from a
  494.   # version (or installed over a version removed-but-not-purged) prior to the
  495.   # one in which the conffile was obsoleted.
  496.  
  497.   local conffile current_checksum
  498.  
  499.   # validate arguments
  500.   if [ $# -lt 2 ]; then
  501.     usage_error "remove_conffile_prepare() called with wrong number of" \
  502.                 "arguments; expected at least 2, got $#"
  503.     exit $SHELL_LIB_USAGE_ERROR
  504.   fi
  505.  
  506.   conffile="$1"
  507.   shift
  508.  
  509.   # does the conffile even exist?
  510.   if [ -e "$conffile" ]; then
  511.     # calculate its checksum
  512.     current_checksum=$(md5sum < "$conffile" | sed 's/[[:space:]].*//')
  513.     # compare it to each supplied checksum
  514.     while [ -n "$1" ]; do
  515.       if [ "$current_checksum" = "$1" ]; then
  516.         # we found a match; move the confffile and stop looking
  517.         observe "preparing obsolete conffile $conffile for removal"
  518.         mv "$conffile" "$conffile.$THIS_PACKAGE-tmp"
  519.         break
  520.       fi
  521.       shift
  522.     done
  523.   fi
  524. }
  525.  
  526. remove_conffile_lookup () {
  527.   # syntax: remove_conffile_lookup package filename
  528.   #
  529.   # Lookup the md5sum of a conffile in dpkg's database, and prepare for removal
  530.   # if it matches the actual file's md5sum.
  531.   #
  532.   # Call this function when you would call remove_conffile_prepare but only
  533.   # want to check against dpkg's status database instead of known checksums.
  534.  
  535.   local package conffile old_md5sum
  536.  
  537.   # validate arguments
  538.   if [ $# -ne 2 ]; then
  539.     usage_error "remove_conffile_lookup() called with wrong number of" \
  540.                 "arguments; expected 1, got $#"
  541.     exit $SHELL_LIB_USAGE_ERROR
  542.   fi
  543.  
  544.   package="$1"
  545.   conffile="$2"
  546.  
  547.   if ! [ -e "$conffile" ]; then
  548.     return
  549.   fi
  550.   old_md5sum="$(dpkg-query -W -f='${Conffiles}' "$package" | \
  551.     awk '{ if (match($0, "^ '"$conffile"' ")) print $2}')"
  552.   if [ -n "$old_md5sum" ]; then
  553.     remove_conffile_prepare "$conffile" "$old_md5sum"
  554.   fi
  555. }
  556.  
  557. remove_conffile_commit () {
  558.   # syntax: remove_conffile_commit filename
  559.   #
  560.   # Complete the removal of a conffile "filename" that has become obsolete.
  561.   #
  562.   # Call this function from a postinst script after having used
  563.   # remove_conffile_prepare() in the preinst.
  564.  
  565.   local conffile
  566.  
  567.   # validate arguments
  568.   if [ $# -ne 1 ]; then
  569.     usage_error "remove_conffile_commit() called with wrong number of" \
  570.                 "arguments; expected 1, got $#"
  571.     exit $SHELL_LIB_USAGE_ERROR
  572.   fi
  573.  
  574.   conffile="$1"
  575.  
  576.   # if the temporary file created by remove_conffile_prepare() exists, remove it
  577.   if [ -e "$conffile.$THIS_PACKAGE-tmp" ]; then
  578.     observe "committing removal of obsolete conffile $conffile"
  579.     rm "$conffile.$THIS_PACKAGE-tmp"
  580.   fi
  581. }
  582.  
  583. remove_conffile_rollback () {
  584.   # syntax: remove_conffile_rollback filename
  585.   #
  586.   # Roll back the removal of a conffile "filename".
  587.   #
  588.   # Call this function from a postrm script in the event $1 is "abort-upgrade"
  589.   # or "abort-install" is  after having used remove_conffile_prepare() in the
  590.   # preinst.
  591.  
  592.   local conffile
  593.  
  594.   # validate arguments
  595.   if [ $# -ne 1 ]; then
  596.     usage_error "remove_conffile_rollback() called with wrong number of" \
  597.                 "arguments; expected 1, got $#"
  598.     exit $SHELL_LIB_USAGE_ERROR
  599.   fi
  600.  
  601.   conffile="$1"
  602.  
  603.   # if the temporary file created by remove_conffile_prepare() exists, move it
  604.   # back
  605.   if [ -e "$conffile.$THIS_PACKAGE-tmp" ]; then
  606.     observe "rolling back removal of obsolete conffile $conffile"
  607.     mv "$conffile.$THIS_PACKAGE-tmp" "$conffile"
  608.   fi
  609. }
  610.  
  611. replace_conffile_with_symlink_prepare () {
  612.   # syntax: replace_conffile_with_symlink_prepare oldfilename newfilename \
  613.   # official_md5sum ...
  614.   #
  615.   # Check a conffile "oldfilename" against a list of canonical MD5 checksums.
  616.   # If the file's current MD5 checksum matches one of the "official_md5sum"
  617.   # operands provided, then prepare the conffile for removal from the system.
  618.   # We defer actual deletion until the package is configured so that we can
  619.   # roll this operation back if package installation fails. Otherwise copy it
  620.   # to newfilename and let dpkg handle it through conffiles mechanism.
  621.   #
  622.   # Call this function from a preinst script in the event $1 is "upgrade" or
  623.   # "install" and verify $2 to ensure the package is being upgraded from a
  624.   # version (or installed over a version removed-but-not-purged) prior to the
  625.   # one in which the conffile was obsoleted.
  626.  
  627.   local conffile current_checksum
  628.  
  629.   # validate arguments
  630.   if [ $# -lt 3 ]; then
  631.     usage_error "replace_conffile_with_symlink_prepare() called with wrong" \
  632.                 " number of arguments; expected at least 3, got $#"
  633.     exit $SHELL_LIB_USAGE_ERROR
  634.   fi
  635.  
  636.   oldconffile="$1"
  637.   shift
  638.   newconffile="$1"
  639.   shift
  640.  
  641.   remove_conffile_prepare "$_oldconffile" "$@"
  642.   # If $oldconffile still exists, then md5sums didn't match.
  643.   # Copy it to new one.
  644.   if [ -f "$oldconffile" ]; then
  645.     cp "$oldconffile" "$newconffile"
  646.   fi
  647.  
  648. }
  649.  
  650. replace_conffile_with_symlink_commit () {
  651.   # syntax: replace_conffile_with_symlink_commit oldfilename
  652.   #
  653.   # Complete the removal of a conffile "oldfilename" that has been
  654.   # replaced by a symlink.
  655.   #
  656.   # Call this function from a postinst script after having used
  657.   # replace_conffile_with_symlink_prepare() in the preinst.
  658.  
  659.   local conffile
  660.  
  661.   # validate arguments
  662.   if [ $# -ne 1 ]; then
  663.     usage_error "replace_conffile_with_symlink_commit() called with wrong" \
  664.                 "number of arguments; expected 1, got $#"
  665.     exit $SHELL_LIB_USAGE_ERROR
  666.   fi
  667.  
  668.   conffile="$1"
  669.  
  670.   remove_conffile_commit "$conffile"
  671. }
  672.  
  673. replace_conffile_with_symlink_rollback () {
  674.   # syntax: replace_conffile_with_symlink_rollback oldfilename newfilename
  675.   #
  676.   # Roll back the replacing of a conffile "oldfilename" with symlink to
  677.   # "newfilename".
  678.   #
  679.   # Call this function from a postrm script in the event $1 is "abort-upgrade"
  680.   # or "abort-install" and verify $2 to ensure the package failed to upgrade
  681.   # from a version (or install over a version removed-but-not-purged) prior
  682.   # to the one in which the conffile was obsoleted.
  683.   # You should have  used replace_conffile_with_symlink_prepare() in the
  684.   # preinst.
  685.  
  686.   local conffile
  687.  
  688.   # validate arguments
  689.   if [ $# -ne 2 ]; then
  690.     usage_error "replace_conffile_with_symlink_rollback() called with wrong" \
  691.                 "number of arguments; expected 2, got $#"
  692.     exit $SHELL_LIB_USAGE_ERROR
  693.   fi
  694.  
  695.   oldconffile="$1"
  696.   newconffile="$2"
  697.  
  698.   remove_conffile_rollback "$_oldconffile"
  699.   if [ -f "$newconffile" ]; then
  700.     rm "$newconffile"
  701.   fi
  702. }
  703.  
  704. run () {
  705.   # syntax: run command [ argument ... ]
  706.   #
  707.   # Run specified command with optional arguments and report its exit status.
  708.   # Useful for commands whose exit status may be nonzero, but still acceptable,
  709.   # or commands whose failure is not fatal to us.
  710.   #
  711.   # NOTE: Do *not* use this function with db_get or db_metaget commands; in
  712.   # those cases the return value of the debconf command *must* be checked
  713.   # before the string returned by debconf is used for anything.
  714.  
  715.   local retval
  716.  
  717.   # validate arguments
  718.   if [ $# -lt 1 ]; then
  719.     usage_error "run() called with wrong number of arguments; expected at" \
  720.                 "least 1, got $#"
  721.     exit $SHELL_LIB_USAGE_ERROR
  722.   fi
  723.  
  724.   "$@" || retval=$?
  725.  
  726.   if [ ${retval:-0} -ne 0 ]; then
  727.     observe "command \"$*\" exited with status $retval"
  728.   fi
  729. }
  730.  
  731. make_symlink_sane () {
  732.   # syntax: make_symlink_sane symlink target
  733.   #
  734.   # Ensure that the symbolic link symlink exists, and points to target.
  735.   #
  736.   # If symlink does not exist, create it and point it at target.
  737.   #
  738.   # If symlink exists but is not a symbolic link, back it up.
  739.   #
  740.   # If symlink exists, is a symbolic link, but points to the wrong location, fix
  741.   # it.
  742.   #
  743.   # If symlink exists, is a symbolic link, and already points to target, do
  744.   # nothing.
  745.   #
  746.   # This function wouldn't be needed if ln had an -I, --idempotent option.
  747.  
  748.   # Validate arguments.
  749.   if [ $# -ne 2 ]; then
  750.     usage_error "make_symlink_sane() called with wrong number of arguments;" \
  751.       "expected 2, got $#"
  752.     exit $SHELL_LIB_USAGE_ERROR
  753.   fi
  754.  
  755.   # We could just use the positional parameters as-is, but that makes things
  756.   # harder to follow.
  757.   local symlink target
  758.  
  759.   symlink="$1"
  760.   target="$2"
  761.  
  762.   if [ -L "$symlink" ] && [ "$(readlink "$symlink")" = "$target" ]; then
  763.       observe "link from $symlink to $target already exists"
  764.   else
  765.     observe "creating symbolic link from $symlink to $target"
  766.     mkdir -p "${target%/*}" "${symlink%/*}"
  767.     ln -s -b -S ".dpkg-old" "$target" "$symlink"
  768.   fi
  769. }
  770.  
  771. migrate_dir_to_symlink () {
  772.   # syntax: migrate_dir_to_symlink old_location new_location
  773.   #
  774.   # Per Debian Policy section 6.5.4, "A directory will never be replaced by a
  775.   # symbolic link to a directory or vice versa; instead, the existing state
  776.   # (symlink or not) will be left alone and dpkg will follow the symlink if
  777.   # there is one."
  778.   #
  779.   # We have to do it ourselves.
  780.   #
  781.   # This function moves the contents of old_location, a directory, into
  782.   # new_location, a directory, then makes old_location a symbolic link to
  783.   # new_location.
  784.   #
  785.   # old_location need not exist, but if it does, it must be a directory (or a
  786.   # symlink to a directory).  If it is not, it is backed up.  If new_location
  787.   # exists already and is not a directory, it is backed up.
  788.   #
  789.   # This function should be called from a package's preinst so that other
  790.   # packages unpacked after this one --- but before this package's postinst runs
  791.   # --- are unpacked into new_location even if their payloads contain
  792.   # old_location filespecs.
  793.  
  794.   # Validate arguments.
  795.   if [ $# -ne 2 ]; then
  796.     usage_error "migrate_dir_to_symlink() called with wrong number of"
  797.                 "arguments; expected 2, got $#"
  798.     exit $SHELL_LIB_USAGE_ERROR
  799.   fi
  800.  
  801.   # We could just use the positional parameters as-is, but that makes things
  802.   # harder to follow.
  803.   local new old
  804.  
  805.   old="$1"
  806.   new="$2"
  807.  
  808.   # Is old location a symlink?
  809.   if [ -L "$old" ]; then
  810.     # Does it already point to new location?
  811.     if [ "$(readlink "$old")" = "$new" ]; then
  812.       # Nothing to do; migration has already been done.
  813.       observe "migration of $old to $new already done"
  814.       return 0
  815.     else
  816.       # Back it up.
  817.       warn "backing up symbolic link $old as $old.dpkg-old"
  818.       mv -b "$old" "$old.dpkg-old"
  819.     fi
  820.   fi
  821.  
  822.   # Does old location exist, but is not a directory?
  823.   if [ -e "$old" ] && ! [ -d "$old" ]; then
  824.       # Back it up.
  825.       warn "backing up non-directory $old as $old.dpkg-old"
  826.       mv -b "$old" "$old.dpkg-old"
  827.   fi
  828.  
  829.   observe "migrating $old to $new"
  830.  
  831.   # Is new location a symlink?
  832.   if [ -L "$new" ]; then
  833.     # Does it point the wrong way, i.e., back to where we're migrating from?
  834.     if [ "$(readlink "$new")" = "$old" ]; then
  835.       # Get rid of it.
  836.       observe "removing symbolic link $new which points to $old"
  837.       rm "$new"
  838.     else
  839.       # Back it up.
  840.       warn "backing up symbolic link $new as $new.dpkg-old"
  841.       mv -b "$new" "$new.dpkg-old"
  842.     fi
  843.   fi
  844.  
  845.   # Does new location exist, but is not a directory?
  846.   if [ -e "$new" ] && ! [ -d "$new" ]; then
  847.     warn "backing up non-directory $new as $new.dpkg-old"
  848.     mv -b "$new" "$new.dpkg-old"
  849.   fi
  850.  
  851.   # Create new directory if it does not yet exist.
  852.   if ! [ -e "$new" ]; then
  853.     observe "creating $new"
  854.     mkdir -p "$new"
  855.   fi
  856.  
  857.   # Copy files in old location to new location.  Back up any filenames that
  858.   # already exist in the new location with the extension ".dpkg-old".
  859.   observe "copying files from $old to $new"
  860.   if ! (cd "$old" && cp -a -b -S ".dpkg-old" . "$new"); then
  861.     die "error(s) encountered while copying files from $old to $new"
  862.   fi
  863.  
  864.   # Remove files at old location.
  865.   observe "removing $old"
  866.   rm -r "$old"
  867.  
  868.   # Create symlink from old location to new location.
  869.   make_symlink_sane "$old" "$new"
  870. }
  871.  
  872. # vim:set ai et sw=2 ts=2 tw=80:
  873.  
  874. # GOBSTOPPER: The X Strike Force shell library ends here.
  875.  
  876. if [ "$1" = "install" ] || [ "$1" = "upgrade" ]; then
  877.  
  878.   if dpkg --compare-versions "$2" lt-nl "1:7.4~2ubuntu1"; then
  879.     remove_conffile_lookup xinit "/etc/X11/Xsession.d/20xorg-common_process-args"
  880.     remove_conffile_lookup xinit "/etc/X11/Xsession.d/30xorg-common_xresources"
  881.     remove_conffile_lookup xinit "/etc/X11/Xsession.d/50xorg-common_determine-startup"
  882.     remove_conffile_lookup xinit "/etc/X11/Xsession.d/90xorg-common_ssh-agent"
  883.     remove_conffile_lookup xinit "/etc/X11/Xsession.d/99xorg-common_start"
  884.   fi
  885.   if dpkg --compare-versions "$2" lt-nl "1:7.4~5ubuntu16"; then
  886.     remove_conffile_lookup x11-common "/etc/X11/Xsession.d/60x11-localhost"
  887.   fi
  888.  
  889.   # create the configuration files' main and auxiliary directories if they
  890.   # don't exist
  891.   for DIR in "$CONFIG_DIR" "$CONFIG_AUX_DIR"; do
  892.     if ! [ -e "$DIR" ]; then
  893.       observe "creating $DIR"
  894.       mkdir --mode=755 --parents "$DIR"
  895.     fi
  896.   done
  897.  
  898.   # place config files under management if they do *not* already exist
  899.   if ! [ -e "$XWRAPPER_CONFIG" ]; then
  900.     touch "$XWRAPPER_CONFIG"
  901.     md5sum "$XWRAPPER_CONFIG" > "$XWRAPPER_CONFIG_CHECKSUM"
  902.   fi
  903. fi
  904.  
  905.  
  906.  
  907. exit 0
  908.  
  909. # vim:set ai et sts=2 sw=2 tw=0:
  910.